      $set rtncode-size"2" nolitlink
      ************************************************************************
      *
      * Copyright (C) 1986-1999 Micro Focus Ltd.
      *
      * All rights reserved.  Unpublished, all rights reserved under
      * copyright law and cobol-international treaty.  Use of a copyright notice
      * is precautionary only and does not imply publication or disclosure.
      * This software contains confidential information and trade secrets of
      * Micro Focus Ltd. and no part of this program or publication may be
      * reproduced, transmitted, transcribed, stored in a retrieval system,
      * or translated cobol-into any language or computer language, in any form
      * or by any means, electronic, mechanical, magnetic, optical, chemical,
      * manual or otherwise, without the prior written permission of:
      *
      * Micro Focus Ltd,
      * The Lawn, Old Bath Road, Newbury, Berkshire, RG14 1QN, UK.
      * (01635) 32646
      *
      * RESTRICTED RIGHTS LEGEND
      * Use, duplication, or disclosure by the Government is subject to
      * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights
      * in Technical Data and Computer Software clause at DFARS 52.227-7013
      * or subparagraphs (c)(1) and (2) of Commercial Computer Software -
      * Restricted Rights at 48 CFR 52.227-19, as applicable.  Contact
      * Micro Focus Incorporated, 2465 East Bayshore Road, Palo Alto,
      * California 94303.
      *
      *
      ************************************************************************
      *
      * Start of source module cobmain1.cbl
      *
      ************************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. cobmain1.

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.

       WORKING-STORAGE SECTION.
       copy "ctypes.cpy".
	01 cobol-double d-float.
	01 cobol-float float.
	01 cobol-long long.
	01 cobol-int int.
	01 cobol-char pic x(25) value all x"00".

	01 mainline pic x(80).
	01 subline pic x(80) value
	    "Value 1 is %x : Value 2 is %s : Value 3 is %d".
        01 num1 pic 9(8) comp-x.
	01 num2 pic 99.
	01 filler pic x value x"00".
	01 num3 pic 9(8) comp-x.

	01 preloadobj	procedure-pointer.
	01 preloaderr	procedure-pointer.

	01 result pic 9(4) comp-x.
       PROCEDURE DIVISION.

     ***
     *** This part demonstrates COBOL
     *** calling a C function directly
     ***
	move 9999 to cobol-double
	move 10 to cobol-long
	move 10.5 to cobol-float
	move -10 to cobol-int
	move "abcdefghijklmnopqrst" & x"00" to cobol-char

	call "csub1" using	by value cobol-int
				by reference cobol-float
				by reference cobol-long
				by reference cobol-char
				by reference cobol-double
				returning result

	if result = 0
	    display "cobmain1 running correctly"
	else
	    display "cobmain1 failed"
	end-if

     ***
     *** This part just demonstrates COBOL
     *** calling a C library routine
     ***
	    move 1234 to num1
	    move 10 to num2
	    move 25 to num3
	    call "sprintf" using by reference	mainline
				 by reference	subline
				 by value	num1
				 by reference	num2
				 by value	num3
	    display mainline


     ***
     *** This part demonstrates COBOL
     *** calling a C++ function. We're also using this
     *** opportunity to demo calling a function with a
     *** differing name to the shared object.
     ***

     ***
     *** As none of the function names are the same name as the
     *** shared object, we need to preload the shared object to make
     *** the functions available.
     ***
	    set preloadobj to entry "cxxsub1"
	    set preloaderr to entry "doesnotexit"
	    if preloadobj equal preloaderr
	        display "Unable to load cxxsub1"
		stop run
	    end-if

	move 9999 to cobol-double
	move 10 to cobol-long
	move 10.5 to cobol-float
	move -10 to cobol-int
	move "abcdefghijklmnopqrst" & x"00" to cobol-char

	call "cplusfunc" using	by value cobol-int
				by reference cobol-float
				by reference cobol-long
				by reference cobol-char
				by reference cobol-double
				returning result

	if result = 0
	    display "cobmain1 running correctly"
	else
	    display "cobmain1 failed"
	end-if

	display "return-code" result
	move result to return-code
	exit program.
