      $set mfoo ooctrl(+n)
      *------------------------------------------------------------
      * CheckAccount is a sub-class derived from the class
      * Account.
      *
      * Copyright (c) Micro Focus 1996-1999.
      *------------------------------------------------------------
       class-id. CheckAccount
              data is protected
              inherits from Account with data.


        object section.
        class-control.
           Account is class "account"
           CheckAccount is class "caccount"
           ExceptionManager is class "exptnmgr"
           .
       working-storage section.
           copy "accinfo.cpy".
       class-object.
       object-storage section.
      *------------------------------------------------------------
      * Set the first account number for Check accounts.
      *------------------------------------------------------------
       Method-id. "getFirstAccountNumber".

       linkage section.
           01  lnkNumber               pic 9(8).
       procedure division returning lnkNumber.
      *----C0001. Set up account numbering for checking accounts.
           move 10000000 to lnkNumber
           exit method.
       end method "getFirstAccountNumber".
       end class-object.
       Object.
       object-storage section.

           01  permittedOverdraft          pic S9(10)v99 comp-5 value 0.

      *------------------------------------------------------------
      * Implementation of "withdraw" which allows for overdrafts.
      *------------------------------------------------------------

       method-id. "withdraw".

       local-storage section.
           01 workingValue         pic S9(10)v99.
           01 lsErrorNumber        pic x(4) comp-5.
           01 lsErrorObject        object reference.
       linkage section.
           01 lsAmount             pic 9(10)v99.

       procedure division using lsAmount.
      *----C010. Withdraw lsAmount from this account
           subtract lsAmount from balance giving workingValue
           if workingValue < permittedOverdraft
               invoke ExceptionManager "queryMessageFile"
                                       using "bank" "account"
                                   returning lsErrorNumber
               add debitExceedsOverdraft to lsErrorNumber
               invoke self "raiseException" using lsErrorNumber
                                        returning lsErrorObject

           else
               move workingValue to balance
           end-if
          exit method.
       end method "withdraw".

      *------------------------------------------------------------
      * Sets an overdraft limit for this account.
      *------------------------------------------------------------
       method-id. "setOverdraft".

       linkage section.
           01 lsOverdraft          pic S9(10)v99.

       procedure division using lsOverdraft.
      *----C020. Set the overdraft.
           move lsOverdraft to permittedOverdraft
           exit method.
       end method "setOverdraft".

      *------------------------------------------------------------
      * Dummy code pretending to print a statement
      *------------------------------------------------------------

       method-id. "printStatement".
       local-storage section.
           01  displayBalance       pic -(9)9.99.


       procedure division.
      *----C040. Print a statement.
           display "Check Account"
           display "Name:     " aName
           move balance to displayBalance
           display "Balance : " displayBalance
           exit method.
       end method "printStatement".

      *-----------------------------------------------------------------
      * Return the type of account.
      *-----------------------------------------------------------------
       method-id. "getType".

       linkage section.
           01  lsType          pic x(accTypeLength).

       procedure division returning lsType.
      *----C050. Return the account atype.
           move spaces to lsType
           move checkType to lsType
           exit method.
       end method "getType".
       end object.
       end class CheckAccount.
