      $set mfoo ooctrl(+n)
      *------------------------------------------------------------
      * Program to create five different types of collection and
      * initialize with intrinsic values.
      *------------------------------------------------------------
      * Copyright Micro Focus Limited 1996-1999.All Rights Reserved.
      * This demonstration program is provided for use by users of
      * Micro Focus products and may be used, modified and
      * distributed as part of your application provided that you
      * properly acknowledge the copyright of Micro Focus in this
      * material.
      *------------------------------------------------------------

       class-control.
           Array is class "array"
           CobolCompX is class "compx"
           .

       working-storage section.
      *----Data for initializing the collections
           01  loopCount               pic x(4) comp-5.
           01  element                 pic x(4) comp-x.
           01  i                       pic x(4) comp-5.

      *----Object references to hold array instances and
      *    a class template for COBOL intrinsic data.
           01  anArray                 object reference.
           01  picx4comp5              object reference.

       procedure division.
      *----A001. Create a new class representing PIC X(4) COMP-5
      *          COBOL intrinsic data.

           move 4 to i
           invoke cobolcompX "newClass" using i
                                    returning picx4comp5
      *----A002. Create an array of  10 elements for COBOL intrinsic
      *          data.
           move 10 to i
           invoke Array "ofValues" using picx4comp5 i
                               returning anArray
      *----A003. Store the integers from 10 counting down to 1
           move 10 to element
           perform varying loopCount from 1 by 1
                                     until loopCount > 10
               invoke anArray "atPut" using loopCount element
                                  returning element
           subtract 1 from element
           end-perform

      *----A004. Get the fourth element from the array and display it.
           move 4 to loopCount
           invoke anArray "at" using loopCount
                           returning element
           display element
           display " "



