      $SET SQL(dbman=ODBC, db2)
      ****************************************************************
      *  Copyright Micro Focus Limited 1998.    All Rights Reserved.
      *  This demonstration program is provided for use by users of
      *  Micro Focus products and may be used, modified and
      *  distributed as part of your application provided that you
      *  properly acknowledge the copyright of Micro Focus in this
      *  material.
      *
      ****************************************************************

       working-storage section.

      *  Include the SQL Communications Area. This includes the
      *  definitions of SQLCODE, etc
       exec sql include sqlca end-exec

       exec sql begin declare section end-exec

      *  The option in the sql directive is used here to
      *  make the use of the catalog functions easier.
      *  By specifying db2, a structure such as
      *  Type-Catalog can be specified in a Fetch
      *  statement and it will be handled as if the
      *  individual members of the structure had been
      *  specified separately.
      *
      *  Note that the db2 directive cannot be used in
      *  all programs as it prevents certain Dynamic SQL
      *  statements being used and changes the behavior
      *  of other statements.

       01 Type-Catalog.
        03 Typ-Name                pic x(32).
        03 Typ-Datatype            pic s9(4) comp-5.
        03 Typ-Precision           pic s9(9) comp-5.
        03 Typ-Lit-Prefix          pic x(10).
        03 Typ-Lit-Suffix          pic x(10).
        03 Typ-Create-Pars         pic x(32).
        03 Typ-Nullable            pic s9(4) comp-5.
        03 Typ-Case-Sens           pic s9(4) comp-5.
        03 Typ-Searchable          pic s9(4) comp-5.
        03 Typ-Unsigned            pic s9(4) comp-5.
        03 Typ-Money               pic s9(4) comp-5.
        03 Typ-Auto-Inc            pic s9(4) comp-5.
        03 Typ-Local-Name          pic x(32).
        03 Typ-Min-Scale           pic s9(4) comp-5.
        03 Typ-Max-Scale           pic s9(4) comp-5.

       01 Type-Indicators.
        03 Typ-Inds                pic s9(4) comp-5 occurs 15.

       01 Table-Catalog.
        03 Tab-Qualifier           pic x(32).
        03 Tab-Owner               pic x(32).
        03 Tab-Name                pic x(32).
        03 Tab-Type                pic x(32).

       01 Table-Indicators.
        03 Tab-Inds                pic s9(4) comp-5 occurs 4.

       01 Column-Catalog.
        03 Col-Qualifier           pic x(32).
        03 Col-Owner               pic x(32).
        03 Col-Table-Name          pic x(32).
        03 Col-Name                pic x(32).
        03 Col-Data-Type           pic s9(4) comp-5.
        03 Col-Type-Name           pic x(32).
        03 Col-Precision           pic s9(9) comp-5.
        03 Col-Length              pic s9(9) comp-5.
        03 Col-Scale               pic s9(4) comp-5.
        03 Col-Radix               pic s9(4) comp-5.
        03 Col-Nullable            pic s9(4) comp-5.
        03 Col-Remarks             pic x(254).

       01 Column-Indicators.
        03 Col-Inds                pic s9(4) comp-5 occurs 12.

       01 Svr                      pic x(32).
       01 Usr                      pic x(32).
       01 Pass                     pic x(32).
       01 Usr-Pass                 pic x(64).

       exec sql end declare section end-exec

       01  c                       pic x.

       procedure division.
       main-proc.
      *    Connect to a database
           display "Catalog Statement Demonstration"
           display " "
           display "Enter data source name "
                   with no advancing
           accept Svr
           display "Enter username "
                    with no advancing
           accept Usr
           display "Enter password "
                    with no advancing
           accept Pass
           string
               Usr delimited space
               "." delimited size
               Pass delimited space
           into Usr-Pass
           exec sql
               connect to :Svr user :Usr-pass
           end-exec
           if Sqlcode not = 0
               display "Error: not connected to database"
               display "sqlcode = " Sqlcode
               display "sqlerrmc = " Sqlerrmc
               stop run
           end-if

           display "List of all ODBC datatypes for current session"
           exec sql
               declare dcurs cursor for
                   query odbc datatypes
           end-exec

           exec sql open dcurs end-exec
           if Sqlcode not = 0
               display "Error: querying datatype catalog"
               display "sqlcode = " Sqlcode
               display "sqlerrmc = " Sqlerrmc
               stop run
           end-if

           exec sql fetch dcurs into :Type-catalog:Typ-Inds end-exec
           perform until Sqlcode < 0 or Sqlcode = 100
               if Typ-Inds(6) = 0
      *            If the type needs parameters such as
      *            length, scale or precision, list them
                   display Typ-Name "(" Typ-Create-Pars ")"
               else
                   display Typ-Name
               end-if
               exec sql
                   fetch dcurs into :Type-Catalog:Typ-Inds
               end-exec
           end-perform
           exec sql close dcurs end-exec

           display " "
           display "List of all tables in ODBC catalog"

           exec sql
               declare tcurs cursor for
                   query odbc tables
           end-exec

           exec sql open tcurs end-exec
           if Sqlcode not = 0
               display "Error: querying table catalog"
               display "sqlcode = " Sqlcode
               display "sqlerrmc = " Sqlerrmc
               stop run
           end-if

           exec sql fetch tcurs into :Table-Catalog:Tab-Inds end-exec
           perform until Sqlcode < 0 or Sqlcode = 100
               display Tab-Name Tab-Type(1:20) Tab-Owner(1:20)
               exec sql
                   fetch tcurs into :Table-Catalog:Tab-Inds
               end-exec
           end-perform
           exec sql close tcurs end-exec

           display " "
           display "List of columns for table EMP"

           exec sql
               declare ccurs cursor for
                   query odbc columns tablename 'EMP'
           end-exec

           exec sql open ccurs end-exec
           if Sqlcode not = 0
               display "Error: querying table column catalog"
               display "sqlcode = " Sqlcode
               display "sqlerrmc = " Sqlerrmc
               stop run
           end-if

           exec sql fetch ccurs into :Column-Catalog:Col-Inds end-exec
           perform until Sqlcode < 0 or Sqlcode = 100
               display Col-Name Col-Type-Name
               exec sql
                   fetch ccurs into :Column-Catalog:Col-Inds
               end-exec
           end-perform
           exec sql close ccurs end-exec

           exec sql disconnect current end-exec
           stop run.

