      $set sql(dbman=odbc)
      *************************************************************
      *  Copyright Micro Focus Limited 1998.    All Rights Reserved.
      *  This demonstration program is provided for use by users of
      *  Micro Focus products and may be used, modified and
      *  distributed as part of your application provided that you
      *  properly acknowledge the copyright of Micro Focus in this
      *  material.
      *
      *  This program is used to setup and test the environment
      *  for OpenESQL on UNIX.
      *
      *************************************************************

       special-names.
           crt status is Key-Returned.

       select odbcini
           assign to Odbcini-Name
           organization is line sequential
           file status is Odbcini-Status.

       select Unix-Version
           assign to "< uname"
           file status is Unix-Version-Status.

       select Work-File
           assign to Work-File-Name
           organization is line sequential
           file status is Work-File-Status.

       select Log-File
           assign to "esqlconf.log"
           organization is line sequential
           file status is Log-File-Status.

       data division.
       file section.

       fd odbcini.

       01 odbcini-File-Record      pic x(256).

       fd Unix-Version.

       01 Unix-Details             pic x(80).

       fd Work-File.

       01 Work-File-Record         pic x(80).

       fd Log-File.

       01 Log-Record               pic x(160).

       working-storage section.

       01 Odbcini-File-Details.
        03 Odbcini-Name            pic x(256).
        03 Odbcini-Status.
         05 Odbcini-Status-1       pic x.
         05 Odbcini-Status-2       pic x comp-x.
        03 Odbcini-EOF             pic x comp-x.
        03 Odbcini-Changed         pic x comp-x.

      * Odbcini location indicates where the odbc.ini file
      * is located.
      *
      *     0 = odbc.ini does not exist
      *     1 = odbc.ini found in local directory
      *     2 = odbc.ini specified in ODBCINI environment variable
      *     3 = odbc.ini in HOME directory

        03 Odbcini-Location        pic x comp-x value 0.

      * Odbcini-Records holds the contents of the odbc.ini
      * file. Odbcini-Size is set to the maximum number of records
      * we expect in the file. Odbcini-Record-Count keeps
      * track of the number of records in the file.

       78 Odbcini-Size             value 500.
       78 Odbcini-Size-Minus-1     value Odbcini-Size - 1.

       01 Odbcini-Records.
        03 Odbcini-Record          pic x(256) occurs Odbcini-Size.

       78 Data-Source-List-Size    value 60.

       01 Data-Source-List.
        03 Data-Source-Record occurs Data-Source-List-Size.
         05 Data-Source-Name       pic x(30).
         05 Data-Source-Driver     pic x(50).

       01 Work-Variables.
        03 Char-Response           pic x.
        03 Current-Rec-Ptr         pic xx comp-5.
        03 Section-Location        pic xx comp-5.
        03 Save-Rec-Ptr            pic xx comp-5.
        03 Insert-Count            pic xx comp-5.
        03 Odbcini-Record-Count    pic xx comp-5 value 0.
        03 Data-Source-Ptr         pic xx comp-5.
        03 Data-Source-Ptr2        pic xx comp-5.
        03 Data-Source-Count       pic xx comp-5 value 0.
        03 Char-Ptr                pic xx comp-5.
        03 String-Len              pic xx comp-5.
        03 Highlit-Line            pic xx comp-5.
        03 Old-Highlit-Line        pic xx comp-5.
        03 Highlit-Screen-Line     pic xx comp-5.
        03 Exit-Program-Flag       pic x comp-x.
        03 Screen-Change-Key       pic x comp-x.
        03 Error-Flag              pic x comp-x.
        03 Text-Found-Flag         pic x comp-x.
        03 Unix-Version-Status.
         05 Unix-Version-Status-1  pic x.
         05 Unix-Version-Status-2  pic x.
        03 Status-Code             pic x(2) comp-5.
        03 Driver-Number           pic x(2) comp-5.
        03 Work-Record             pic x(256).
        03 Work-Name               pic x(30).
        03 Work-Name-Upper         pic x(30).
        03 Work-Driver             pic x(50).

       01 Work-File-Details.
        03 Work-File-Name          pic x(256).
        03 Work-File-Status.
         05 Work-File-Status-1     pic x.
         05 Work-File-Status-2     pic x.

       01 Log-File-Details.
        03 Log-File-Open-Flag       pic x comp-x.
        03 Log-File-Status.
         05 Log-File-Status-1       pic x.
         05 Log-File-Status-2       pic x.

       01 Driver-Env               pic x comp-x.

       78 Unknown-Driver-Env       value 0.
       78 Oracle-Env               value 1.
       78 Sybase-Env               value 2.
       78 Informix-Env             value 3.

       01 Db-Version               pic x comp-x.

       78 Oracle-Unknown           value 0.
       78 Oracle-7                 value 7.
       78 Oracle-8                 value 8.

       01 Unix-Env                 pic x comp-x.

       78 Unknown-Unix-Env         value 0.
       78 Aix-Env                  value 1.
       78 Solaris-Env              value 2.

       01 Unix-Library-Path        pic x(256).

       01 Split-Join-Param.
        03 Param-Length            pic x(2) comp-x value 24.
        03 Splitjoin-Flg1          pic x comp-x value 0.
        03 Splitjoin-Flg2          pic x comp-x.
        03 Path-Strt               pic x(2) comp-x.
        03 Path-Len                pic x(2) comp-x.
        03 Basename-Strt           pic x(2) comp-x.
        03 Basename-Len            pic x(2) comp-x.
        03 Extension-Strt          pic x(2) comp-x.
        03 Extension-Len           pic x(2) comp-x.
        03 Total-Length            pic x(2) comp-x.
        03 Split-Buf-Len           pic x(2) comp-x value 160.
        03 Join-Buf-Len            pic x(2) comp-x.
        03 First-Path-Len          pic x(2) comp-x.

       01 File-Details.
        03 File-Size               pic x(8) comp-x.
        03 Creation-Date           pic x(4).
        03 Creation-Time           pic x(4).

       01 Directory-Details.
        03 Dir-Flags               pic x(4) comp-5 value 0.
        03 Dir-Length              pic x(4) comp-5 value 256.

       01 Keyboard-Control.
        03 Set-Bit-Pairs           pic x comp-x value 1.
        03 Get-Key                 pic x comp-x value 26.
        03 Enable-Function-Keys    pic x(4) value x"01310006".
        03 Enable-Pgup-PgDn        pic x(4) value x"01313502".
        03 Key-Returned.
         05 Key-Type               pic x.
         05 Key-Code-1             pic x comp-x.
         05 Key-Code-1x            pic x redefines Key-Code-1.
         05 Key-Code-2             pic x comp-x.
        03 Key-Returned-2          pic x(3).

       78 Escape-Key               value 0.
       78 F1-Key                   value 1.
       78 F2-Key                   value 2.
       78 F3-Key                   value 3.
       78 F4-Key                   value 4.
       78 F5-Key                   value 5.
       78 PgUp                     value 53.
       78 PgDn                     value 54.
       78 CurUp                    value 5.
       78 CurDown                  value 6.

       01 Divider-Line             pic x(80) value all "-".

       01 Environment-String       pic x(256).
       01 Work-String              pic x(256).
       01 Odbc-Library-Path        pic x(256).

       01 Driver-Section-Information.
        03 Driver-Library          pic x(160).
        03 Driver-Description      pic x(80).
        03 Driver-Server-Name      pic x(80).
        03 Driver-Database         pic x(80).
        03 Driver-LogonID          pic x(80).
        03 Driver-Password         pic x(80).
        03 Driver-Option-Count     pic xx comp-5.
        03 Driver-Options.
         05 Driver-Option occurs 16.
          07 Driver-Option-Name    pic x(40).
          07 Driver-Option-Value   pic x(40).

       01 Option-Name              pic x(40).
       01 Option-Name-Upper        pic x(40).

      *   Generic message returned by ODBC driver manager if it
      *   cannot load a driver.  This could possibly change
      *   between versions of ODBC

       78 Cannot-Load-Driver       value
          "Specified driver could not be loaded".

       exec sql include sqlca end-exec.

       exec sql begin declare section end-exec

       01 Data-Source              pic x(40).
       01 Id-And-Password          pic x(60).
       01 MfSqlMessageText         pic x(512).

       exec sql end declare section end-exec

       copy "esqlini.cpy".

       copy "esqlscrn.cpy".

       procedure division.
       Esqlconv section.
           perform Initialization
           perform Open-And-Read-Odbcini
           if Error-Flag = 0
               perform Get-Data-Sources
               if Error-Flag not = 0
                   perform Create-New-Odbcini
                   perform Get-Data-Sources
               end-if
               perform Edit-Data-Sources
           end-if
           perform Termination
           stop run.

       Open-And-Read-Odbcini section.
           move 0 to Odbcini-Changed
      *    Look for an existing 'odbc.ini' file.
      *    First, look for ODBCINI
           move 0 to Error-Flag
           move spaces to Odbcini-Name
           display "ODBCINI" upon environment-name
           accept Odbcini-Name from environment-value
           if Odbcini-Name not = spaces
      *        ODBCINI is set
               open input Odbcini
               if Odbcini-Status-1 = "0"
      *            odbc.ini specified in ODBCINI
                   move spaces to Log-Record
                   string Odbcini-Name delimited by space
                          " found specified by ODBCINI"
                          delimited by size
                     into Log-Record
                   perform Write-Log-Record
                   move 2 to Odbcini-Location
               end-if
           end-if
           If Odbcini-Location not = 2
      *        Look in the HOME directory
               move spaces to Environment-String
               display "HOME" upon environment-name
               accept Environment-String from environment-value
               if Environment-String not = spaces
                   move spaces to Odbcini-Name
                   string Environment-String delimited by space
                          "/odbc.ini" delimited by size
                     into Odbcini-Name
                   open input Odbcini
                   if Odbcini-Status-1 = "0"
      *                odbc.ini in HOME directory
                       move "odbc.ini found in HOME directory"
                         to Log-Record
                       perform Write-Log-Record
                       move 3 to Odbcini-Location
                   end-if
               end-if
           end-if
           if Odbcini-Location not = 2 and Odbcini-Location not = 3
      *        Finally, look in the local directory
               move "odbc.ini" to Odbcini-Name
               open input Odbcini
               if Odbcini-Status-1 = "0"
      *            odbc.ini found in local directory
                   move 1 to Odbcini-Location
                   move "odbc.ini found in local directory"
                     to Log-Record
                   perform Write-Log-Record
               end-if
           end-if
           if Odbcini-Location > 0
               move 0 to Odbcini-EOF
               perform until Odbcini-EOF not = 0 or
                             Odbcini-Record-Count = Odbcini-Size-Minus-1
                   read Odbcini
                       at end move 1 to Odbcini-EOF
                   end-read
                   if Odbcini-EOF = 0
                       perform Validate-Odbcini-Record
                       if Error-Flag = 0
                           add 1 to Odbcini-Record-Count
                           move Odbcini-File-Record
                             to Odbcini-Record(Odbcini-Record-Count)
                       end-if
                   end-if
               end-perform
      *        Move dummy section marker to end of records
      *        to make later scanning easier
               close Odbcini
               add 1 to Odbcini-Record-Count
               move "[END]" to Odbcini-Record(Odbcini-Record-Count)
               if Odbcini-Location = 1
                   display Local-Odbcini-Found
               else
                   display Global-Odbcini-Found
               end-if
               display Edit-Odbcini-Question
               perform with test after
                       until Char-Response = "N" or "F"
                   accept Edit-Odbcini-Question
                   move function upper-case(Char-Response)
                     to Char-Response
                   if Char-Response = "N"
                       perform Create-New-Odbcini
                       move "N" to Char-Response
                   end-if
               end-perform
           else
      *        Handle case of no odbc.ini
               move "No odbc.ini found" to Log-Record
               perform Write-Log-Record
               display No-Odbcini-Found
               accept No-Odbcini-Found
               if Char-Response = "Y" or Char-Response = "y"
                   perform Create-New-Odbcini
               else
                   move 1 to Error-Flag
               end-if
           end-if.

       Validate-Odbcini-Record section.
      *    Check record in Odbcini-File-Record to see if it
      *    falls into one of the following models
      *
      *        blank
      *        [xxxxxx]
      *        xxxx=yyyyy
      *
           move 0 to Error-Flag
           if Odbcini-File-Record not = spaces
               move 1 to Char-Ptr
               inspect Odbcini-File-Record tallying Char-Ptr
                   for characters before initial "["
               if Char-Ptr < 256
      *            We have a section header ([xxxx])
      *            Find terminating "]"
                   move 1 to String-Len
                   inspect Odbcini-File-Record tallying String-Len
                       for characters before initial "]"
                   if String-Len > 256
                       move 256 to String-Len
                       move "]" to Odbcini-File-Record(256:1)
                   end-if
      *            Now remove any spaces after "[" and before "]"
                   add 1 to Char-Ptr
                   perform until
                           Odbcini-File-Record(Char-Ptr:1) not = space
                       add 1 to Char-Ptr
                   end-perform
                   if Char-Ptr = String-Len
      *                We have "[]". Replace it with "[Unknown]"
                       move "[Unknown]" to Odbcini-File-Record
                       move 1 to Odbcini-Changed
                       move "[] replaced by [Unknown]in odbc.ini"
                         to Log-Record
                       perform Write-Log-Record
                   else
                       subtract 1 from String-Len
                       perform until Odbcini-File-Record(String-Len:1)
                                     not = space
                           subtract 1 from String-Len
                       end-perform
                       subtract Char-Ptr from String-Len
                       add 1 to String-Len
                       move "[" to Work-Record
                       move Odbcini-File-Record(Char-Ptr:String-Len)
                         to Work-Record(2:String-Len)
                       add 2 to String-Len
                       move "]" to Work-Record(String-Len:2)
                       move Work-Record to Odbcini-File-Record
                   end-if
               else
      *            Look for "="
                   move 1 to Char-Ptr
                   inspect Odbcini-File-Record tallying Char-Ptr
                       for characters before initial "="
                   if Char-Ptr > 256
      *                We have an invalid line. Ensure we
      *                dispose of it
                       move 1 to Error-Flag
                       move 1 to Odbcini-Changed
                       move spaces to Log-Record
                       string "Invalid line: " delimited by size
                              Odbcini-File-Record delimited by space
                              " - deleted" delimited by size
                         into Log-Record
                       perform Write-Log-Record
                   end-if
               end-if
           end-if.

       Create-New-Odbcini section.
           move "Creating new odbc.ini" to Log-Record
           perform Write-Log-Record
           move "odbc.ini" to Odbcini-Name
      *    Ensure that the new file will get written out
           move 1 to Odbcini-Location
           move 1 to Odbcini-Changed
      *    Default location of ODBC drivers is $COBDIR/odbc
           display "COBDIR" upon environment-name
           accept Work-String from environment-value
      *    Remove anything after the first directory
           move 1 to Char-Ptr
           inspect Work-String tallying Char-Ptr
                   for characters before initial ":"
           if Char-Ptr < 257
               move spaces to Work-String(Char-Ptr:)
           end-if
           perform with test after until Work-String not = spaces
               display Location-Of-ODBC-Drivers
               accept Location-Of-ODBC-Drivers
           end-perform
      *    Get length of path entered
           move 256 to String-Len
           perform until Work-String(String-Len:1) not = space
               subtract 1 from String-Len
           end-perform
           if Work-String(String-Len:1) = "/"
               move space to Work-String(String-Len:1)
               subtract 1 from String-Len
           end-if
           move spaces to Log-Record
           string Work-String(1:String-Len) delimited by size
                  " specified as location for ODBC drivers"
                  delimited by size
             into Log-Record
           perform Write-Log-Record
      *    Now copy new records into internal storage, substituting
      *    the pathname for any occurence of ODBC_PATH
           move 0 to Current-Rec-Ptr
           perform with test after
                   until Current-Rec-Ptr = New-Odbcini-Rec-Count
               add 1 to Current-Rec-Ptr
               move New-Odbcini-Rec(Current-Rec-Ptr) to Work-Record
      *        Look for an occurence of ODBC_PATH in the line
               move 1 to Char-Ptr
               inspect Work-Record tallying Char-Ptr
                   for characters before initial "ODBC_PATH"
               if Char-Ptr > 256
                   move Work-Record to Odbcini-Record(Current-Rec-Ptr)
               else
                   string Work-Record(1:Char-Ptr + -1) delimited by size
                          Work-String(1:String-Len) delimited by size
                          Work-Record(Char-Ptr + 9:) delimited by space
                     into Odbcini-Record(Current-Rec-Ptr)
               end-if
           end-perform
           move Current-Rec-Ptr to Odbcini-Record-Count.

       Flush-Odbcini section.
           move 0 to Error-Flag
           open output Odbcini
           if Odbcini-Status-1 not = "0"
               move spaces to Log-Record
               string "Unable to open " delimited by size
                      Odbcini-Name delimited by space
                      " for output" delimited by size
                 into Log-Record
               perform Write-Log-Record
               display Odbcini-Open-Error
               accept Odbcini-Open-Error
               if Char-Response = "Y" or Char-Response = "y"
                   go to Flush-Odbcini
               else
                   if Odbcini-Location > 1
                       display Create-Local-Copy
                       accept Create-Local-Copy
                       if Char-Response = "Y" or Char-Response = "y"
                           move "odbc.ini" to Odbcini-Name
                           move 1 to Odbcini-Location
                           go to Flush-Odbcini
                       else
                           move 1 to Error-Flag
                       end-if
                   else
                       move 1 to Error-Flag
                   end-if
               end-if
           end-if
           if Error-Flag = 0
               move 1 to Current-Rec-Ptr
               perform until
                       Odbcini-Record(Current-Rec-Ptr)(1:5) = "[END]"
                   move Odbcini-Record(Current-Rec-Ptr)
                     to Odbcini-File-Record
                   write Odbcini-File-Record
                   add 1 to Current-Rec-Ptr
               end-perform
               close Odbcini
               move 0 to Odbcini-Changed
               move spaces to Log-Record
               string "New version of " delimited by size
                      Odbcini-Name delimited by space
                      " written" delimited by size
                 into Log-Record
           else
               move "Unable to write odbc.ini" to Log-Record
           end-if
           perform Write-Log-Record.

       Get-Data-Sources section.
           move 0 to Error-Flag
      *    Look through odbc.ini records for [ODBC Data Sources] section
           move 0 to Current-Rec-Ptr
           perform with test after
                   until Work-Record(2:17) = "ODBC DATA SOURCES" or
                         Work-Record(2:3) = "END"
               perform Look-For-New-Odbcini-Section
           end-perform
           if Work-Record(2:3) = "END"
               display Bad-Odbcini
               call x"AF" using Get-Key Key-Returned
               move 1 to Error-Flag
           else
               add 1 to Current-Rec-Ptr
               move 0 to Data-Source-Ptr
      *        Read in the list of data sources
               move 0 to Text-Found-Flag
               perform with test after
                       until Text-Found-Flag = 1
                   move Odbcini-Record(Current-Rec-Ptr) to Work-Record
                   if Work-Record(1:1) = "["
                       move 1 to Text-Found-Flag
                   else
                       if Work-Record not = spaces
                           move 1 to Char-Ptr
                           inspect Work-Record tallying Char-Ptr
                                   for characters before initial "="
                           move Work-Record(1: Char-Ptr - 1)
                             to Work-Name
                           add 1 to Char-Ptr
                           perform until Work-Record(Char-Ptr:1)
                                         not = space
                               add 1 to Char-Ptr
                           end-perform
                           move Work-Record(Char-Ptr:) to Work-Driver
      *                    Now look to see if there is a corresponding
      *                    section for this Data Source in the file
                           move Current-Rec-Ptr to Save-Rec-Ptr
                           move function upper-case(Work-Name)
                             to Work-Name-Upper
                           move 30 to String-Len
                           perform until Work-Name-Upper(String-Len:1)
                                         not = space
                               subtract 1 from String-Len
                           end-perform
                           perform with test after
                               until Work-Record(2:String-Len) =
                                     Work-Name-Upper(1:String-Len) or
                                     Work-Record(2:3) = "END"
                               perform Look-For-New-Odbcini-Section
                           end-perform
                           move Save-Rec-Ptr to Current-Rec-Ptr
                           if Work-Record(2:3) not = "END"
                               add 1 to Data-Source-Ptr
                               move Work-Name
                                 to Data-Source-Name(Data-Source-Ptr)
                               move Work-Driver
                                 to Data-Source-Driver(Data-Source-Ptr)
                           else
                               move 1 to Odbcini-Changed
                               move spaces to Log-Record
                               string "Unable to find section "
                                      delimited by size
                                      Work-Name delimited by space
                                      " in odbc.ini" delimited by size
                                 into Log-Record
                               perform Write-Log-Record
                           end-if
                       end-if
                   end-if
                   add 1 to Current-Rec-Ptr
               end-perform
               move Data-Source-Ptr to Data-Source-Count
           end-if.

       Look-For-New-Odbcini-Section section.
      *    Read through the Odbcini records until we find the
      *    start of a new section.  Convert the line to upper case
      *    (for ease of comparison) and return it in Work-Record.
           perform with test after
                   until Odbcini-Record(Current-Rec-Ptr)(1:1) = "["
               add 1 to Current-Rec-Ptr
           end-perform
           move function upper-case(Odbcini-Record(Current-Rec-Ptr))
             to Work-Record.

       Edit-Data-Sources section.
      *    Display the main list of data sources and handle the
      *    keystrokes returned
           move 1 to Data-Source-Ptr
           move 0 to Exit-Program-Flag
           move 1 to Highlit-Line
           perform until Exit-Program-Flag not = 0
               display Data-Source-Screen
               display Data-Source-Menu
               if Data-Source-Ptr + 16 <= Data-Source-Count
                   if Data-Source-Ptr > 1
                       display Data-Source-Next-Prev-Menu
                   else
                       display Data-Source-Next-Menu
                   end-if
               else
                   if Data-Source-Ptr > 1
                        display Data-Source-Prev-Menu
                   end-if
               end-if
               move 0 to Old-Highlit-Line
               move 0 to Screen-Change-Key
               perform until Screen-Change-Key not = 0
      *            Get a key from the keyboard
                   if Highlit-Line not = Old-Highlit-Line
                       perform Change-Highlit-Line
                   end-if
                   call x"AF" using Get-Key Key-Returned
                   evaluate true
                       when Key-Type = "1" and Key-Code-1 = Escape-Key
                           move 1 to Exit-Program-Flag
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = F1-Key) or
                            (Key-Type = "3" and Key-Code-1x = "H") or
                            (Key-Type = "3" and Key-Code-1x = "h")
                           display Edit-Screen-Help
                           call x"AF" using Get-Key Key-Returned
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = F2-Key) or
                            (Key-Type = "3" and Key-Code-1x = "E") or
                            (Key-Type = "3" and Key-Code-1x = "e")
                           perform Edit-Data-Source
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = F3-Key) or
                            (Key-Type = "3" and Key-Code-1x = "A") or
                            (Key-Type = "3" and Key-Code-1x = "a")
                           perform Add-Data-Source
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = F4-Key) or
                            (Key-Type = "3" and Key-Code-1x = "R") or
                            (Key-Type = "3" and Key-Code-1x = "r")
                           perform Delete-Data-Source
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = F5-Key) or
                            (Key-Type = "3" and Key-Code-1x = "T") or
                            (Key-Type = "3" and Key-Code-1x = "t")
                           perform Test-Data-Source
                           move 1 to Screen-Change-Key

                       when (Key-Type = "1" and Key-Code-1 = PgUp) or
                            (Key-Type = "3" and Key-Code-1x = "P") or
                            (Key-Type = "3" and Key-Code-1x = "p")
                           if Data-Source-Ptr > 1
                               If Data-Source-Ptr < 17
                                   move 1 to Data-Source-Ptr
                               else
                                   subtract 16 from Data-Source-Ptr
                               end-if
                               move Data-Source-Ptr to Highlit-Line
                               move 1 to Screen-Change-Key
                           end-if

                       when (Key-Type = "1" and Key-Code-1 = PgDn) or
                            (Key-Type = "3" and Key-Code-1x = "N") or
                            (Key-Type = "3" and Key-Code-1x = "n")
                           if Data-Source-Ptr + 16 <= Data-Source-Count
                               add 16 to Data-Source-Ptr
                               move Data-Source-Ptr to Highlit-Line
                               move 1 to Screen-Change-Key
                           end-if

                       when (Key-Type = "2" and Key-Code-1 = CurUp) or
                            (Key-Type = "3" and Key-Code-1x = "U") or
                            (Key-Type = "3" and Key-Code-1x = "u")
                           if Highlit-Line  > 1
                               if Highlit-Line = Data-Source-Ptr
                                   If Data-Source-Ptr < 17
                                       move 1 to Data-Source-Ptr
                                   else
                                       subtract 16 from Data-Source-Ptr
                                   end-if
                                   move 1 to Screen-Change-Key
                               end-if
                               subtract 1 from Highlit-Line
                           end-if

                       when (Key-Type = "2" and Key-Code-1 = CurDown) or
                            (Key-Type = "3" and Key-Code-1x = "D") or
                            (Key-Type = "3" and Key-Code-1x = "d")
                           if Highlit-Line < Data-Source-Count
                               if Highlit-Line = Data-Source-Ptr + 15
                                   add 16 to Data-Source-Ptr
                                   move 1 to Screen-Change-Key
                               end-if
                               add 1 to Highlit-Line
                           end-if

                   end-evaluate
               end-perform
           end-perform.

       Change-Highlit-Line section.
           if Old-Highlit-Line not = 0
      *        Remove old highlighting
               compute Highlit-Screen-Line = Old-Highlit-Line -
                                             Data-Source-Ptr + 5
               display Remove-Highlight-From-Line
           end-if.
      *    Highlight the current line
           compute Highlit-Screen-Line = Highlit-Line -
                                         Data-Source-Ptr + 5
           display Highlight-Line
           move Highlit-Line to Old-Highlit-Line.

       Test-Data-Source section.
           move 0 to Error-Flag
           move spaces to Log-Record
           string "Testing data source " delimited by size
                  Data-Source-Name(Highlit-Line) delimited by space
             into Log-Record
           perform Write-Log-Record
      *    Before we can test, we need to write out any changes
      *    to ODBC.INI
           if Odbcini-Changed = 1
               perform Flush-Odbcini
           end-if
      *    Now check to see if the odbc.ini will be picked up
           if Error-Flag = 0 and Odbcini-Location not > 1
               display Need-To-Set-Odbcini
               move "ODBCINI not set" to Log-Record
               perform Write-Log-Record
               move 1 to Error-Flag
           end-if
      *    Now, we need to check that the ODBC driver we
      *    are testing is on the appropriate library path
           if Error-Flag = 0
               perform Check-Driver-On-Library-Path
           end-if
      *    Do basic checks for known database client environments
           if Error-Flag = 0
               perform Check-Environment
           end-if
           if Error-Flag = 0
               perform with test after until
                       Key-Type = "0" or
                       (Key-Type = "1" and Key-Code-1 = Escape-Key)
                   display Test-Data-Source-Screen
                   accept Test-Data-Source-Screen
                   if (Key-Type = "1" and Key-Code-1 = F1-Key) or
                      (Key-Type = "3" and Key-Code-1x = "H") or
                      (Key-Type = "3" and Key-Code-1x = "h")
                      display Test-Screen-Help
                       call x"AF" using Get-Key Key-Returned-2
                   end-if
               end-perform
      *        Test for Escape being pressed.
               if Key-Type not = "1" or Key-Code-1 not = Escape-Key
                   string Driver-LogonID delimited by space
                          "." delimited by size
                          Driver-Password delimited by space
                     into Id-And-Password
                   move Data-Source-Name(Highlit-Line) to Data-Source
      *            Attempt to connect to the data source
                   display Attempting-To-Connect-Screen
                   exec sql
                       connect to :Data-Source user :Id-And-Password
                   end-exec
                   if sqlcode = 0
                       display "Connection successful. " at 0501
                       display "Disconnecting ..." at 0525
                       exec sql
                           disconnect current
                       end-exec
                       display "Disconnected" at 0701
                       move "Test successful" to Log-Record
                       perform Write-Log-Record
                   else
                       perform Report-Connect-Error
                   end-if
               else
                   display "Test aborted." at 2001
                   move "Test aborted by user" to Log-Record
                   perform Write-Log-Record
               end-if
           end-if
           display "Press any key to continue ..." at 2001
           call x"AF" using Get-Key Key-Returned.

       Check-Environment section.
           move Unknown-Driver-Env to Driver-Env
           move 0 to Error-Flag
      *    Check environment for specific database clients before
      *    attempting to connect
           move function upper-case(Data-Source-Driver(Highlit-Line))
             to Work-Driver
           move 1 to Char-Ptr
           inspect Work-Driver tallying Char-Ptr
               for characters before initial "ORACLE"
           if Char-Ptr <= 50
               add 7 to Char-Ptr
               evaluate Work-Driver(Char-Ptr:1)
                   when "8"
                       move Oracle-8 to Db-Version
                       move "Oracle 8 driver being tested" to Log-Record

                   when "7"
                       move Oracle-7 to Db-Version
                       move "Oracle 7 driver being tested" to Log-Record

                   when other
                       move Oracle-Unknown to Db-Version
                       move "Oracle driver being tested" to Log-Record

               end-evaluate
               perform Write-Log-Record
               perform Check-For-Oracle-Environment
           else
               move 1 to Char-Ptr
               inspect Work-Driver tallying Char-Ptr
                   for characters before initial "SYBASE"
               if Char-Ptr <= 50
                   move "Sybase driver being tested" to Log-Record
                   perform Write-Log-Record
                   perform Check-For-Sybase-Environment
               else
                   move 1 to Char-Ptr
                   inspect Work-Driver tallying Char-Ptr
                       for characters before initial "INFORMIX"
                   if Char-Ptr <= 50
                       move "Informix driver being tested" to Log-Record
                       perform Write-Log-Record
                       perform Check-For-Informix-Environment
                   end-if
               end-if
           end-if.

       Check-For-Oracle-Environment section.
      *    Look for ORACLE_HOME environment variable
           move spaces to Environment-String
           display "ORACLE_HOME" upon environment-name
           accept Environment-String from environment-value
           if Environment-String = spaces
               move "ORACLE_HOME environment variable not set"
                 to Log-Record
               perform Write-Log-Record
               display Oracle-Home-Message
               move 1 to Error-Flag
           else
               move "ORACLE_HOME environment variable set"
                 to Log-Record
               perform Write-Log-Record
               move Oracle-Env to Driver-Env
               perform Check-Library-Path-Set
               if Error-Flag = 0 and Unix-Env = Aix-Env
                   perform Check-Oracle-Version
                   if Error-Flag = 0 and Db-Version = Oracle-7
                       perform Check-For-Oracle-Shared-Object
                   end-if
               end-if
           end-if.

       Check-Oracle-Version section.
      *    See if can determine the Oracle client version
      *    that is installed
           move "$ORACLE_HOME/orainst/RELVER" to Work-File-Name
      *    Try to open the file. We don't give an error
      *    if we cannot as it only seems to be present
      *    on Oracle 7 systems.
           open input Work-File
           if Work-File-Status-1 = "0"
               read Work-File
               if Work-File-Record(1:16) = "RELEASE_VERSION="
                   move "Oracle RELVER file found" to Log-Record
                   perform Write-Log-Record
                   if Work-File-Record(17:1) = "7"
                       move "Oracle 7 client detected" to Log-Record
                       perform Write-Log-Record
                       if Db-Version = Oracle-8
                           move "The Oracle 8 client is required."
                             to Log-Record
                           perform Write-Log-Record
                           display Not-Oracle-8-Client
                           accept Not-Oracle-8-Client
                           if Char-Response = "N" or
                              Char-Response = "n"
                               move 1 to Error-Flag
                           end-if
                       end-if
                   end-if
               else
                   move "Unable to determine Oracle client version"
                     to Log-Record
                   perform Write-Log-Record
               end-if
               close Work-File
           else
               move "Unable to determine Oracle client version number"
                 to Log-Record
               perform Write-Log-Record
           end-if.

       Check-For-Oracle-Shared-Object section.
      *    This is only performed on AIX and we are testing Oracle 7.
      *    Check to see if the file ivoracle7.so exists in the
      *    Odbc driver lib directory.
      *
      *    At this point, the directory containing the ODBC driver
      *    shared objects will be in Odbc-Library-Path (it was setup
      *    by Check-Driver-On-Library-Path).
           move spaces to Work-String
           string Odbc-Library-Path delimited by space
                  "/ivoracle7.so" delimited by size
             into Work-String
           call "CBL_CHECK_FILE_EXIST" using Work-String
                                             File-Details
                                       returning Status-Code
           if Status-Code not = 0
               move "Unable to locate ivoracle7.so" to Log-Record
               perform Write-Log-Record
               display No-Ivoracle7
               accept No-Ivoracle7
               if Char-Response = "Y" or Char-Response = "y"
                   perform Build-Oracle-Shared-Object
               else
                   move 1 to Error-Flag
               end-if
           else
               move "ivoracle7.so found" to Log-Record
               perform Write-Log-Record
           end-if.

       Build-Oracle-Shared-Object section.
           move spaces to Environment-String
           call "CBL_GET_CURRENT_DIR"
               using by value Dir-Flags
                     by value Dir-Length
                     by reference Environment-String
               returning Status-Code
           if Status-Code not = 0
               move 1 to Error-Flag
           else
               move 256 to Char-Ptr
               perform until Odbc-Library-Path(Char-Ptr:1) not = space
                   subtract 1 from Char-Ptr
               end-perform
      *        Char-Ptr will now point to the last character of /lib.
               subtract 4 from Char-Ptr
               move spaces to Work-String
      *        Build up the string to cd to the directory containing
      *        the genclntsh script and the execute it, redirecting
      *        the output to genclntsh.log in the current directory.
               string "cd " delimited by size
                      Odbc-Library-Path(1:Char-Ptr) delimited by size
                      "/src/oracle; genclntsh > " delimited by size
                      Environment-String delimited by space
                      "/genclntsh.log" delimited by size
                      X"00" delimited by size
                 into Work-String
               call "system" using Work-String
      *        Check to see if we were successful
               move spaces to Work-String
               string Odbc-Library-Path delimited by space
                      "/ivoracle7.so" delimited by size
                 into Work-String
               call "CBL_CHECK_FILE_EXIST" using Work-String
                                                 File-Details
                                       returning Status-Code
               if Status-Code not = 0
                   move "Cannot create ivoracle7.so" to Log-Record
                   perform Write-Log-Record
                   move spaces to Work-String
                   string Odbc-Library-Path(1:Char-Ptr)
                          delimited by size
                          "/src/oracle" delimited by size
                     into Work-String
                   display Cannot-Create-Ivoracle7
                   move 1 to Error-Flag
               else
                   move "ivoracle7.so created successfully"
                     to Log-Record
                   perform Write-Log-Record
               end-if
           end-if.

       Check-For-Sybase-Environment section.
      *    Look for SYBASE environment variable
           move spaces to Environment-String
           display "SYBASE" upon environment-name
           accept Environment-String from environment-value
           if Environment-String = spaces
               move "SYBASE environment variable not set"
                 to Log-Record
               perform Write-Log-Record
               display Sybase-Message
               move 1 to Error-Flag
           else
               move "SYBASE environment variable set"
                 to Log-Record
               perform Write-Log-Record
               move Sybase-Env to Driver-Env
               perform Check-Library-Path-Set
           end-if.

       Check-For-Informix-Environment section.
      *    Look for INFORMIXDIR environment variable
           move spaces to Environment-String
           display "INFORMIXDIR" upon environment-name
           accept Environment-String from environment-value
           if Environment-String = spaces
               move "INFORMIXDIR environment variable not set"
                 to Log-Record
               perform Write-Log-Record
               display InformixDir-Message
               move 1 to Error-Flag
           else
               move "INFORMIXDIR environment variable set"
                 to Log-Record
               perform Write-Log-Record
               move Informix-Env to Driver-Env
               perform Check-Library-Path-Set
           end-if.

       Check-Library-Path-Set section.
           if Unix-Env not = Unknown-Unix-Env
      *        Ensure that the shared objects for the database client
      *        are on the correct path
      *
      *        Environment string will be already setup with the
      *        relevant database environment variable (e.g. SYBASE,
      *        ORACLE_HOME or INFORMIXDIR). Append "/lib" to it
               move spaces to Work-String
               string Environment-String delimited by space
                      "/lib" delimited by size
                 into Work-String
      *        Determine the length of the path
               move 256 to String-Len
               perform until Work-String(String-Len:1) not = space
                   subtract 1 from String-Len
               end-perform
      *        See if this path is on the appropriate environment
      *        variable (LIBPATH or LD_LIBRARY_PATH)
               move 1 to Char-Ptr
               inspect Unix-Library-Path tallying Char-Ptr
                   for characters
                   before initial Work-String(1:String-Len)
               if Unix-Env = Aix-Env
                   move "LIBPATH" to Environment-String
               else
                   move "LD_LIBRARY_PATH" to Environment-String
               end-if
               if Char-Ptr > 256
      *            The directory containing the client shared
      *            objects is not on the appropriate environment
      *            variable
                   display Database-Library-Message
                   move spaces to Log-Record
                   string Work-String(1:String-Len) delimited by size
                          " not on " delimited by size
                          Environment-String delimited by space
                     into Log-Record
                   perform Write-Log-Record
                   move 1 to Error-Flag
               else
                   move spaces to Log-Record
                   string Work-String(1:String-Len) delimited by size
                          " on " delimited by size
                          Environment-String delimited by space
                     into Log-Record
                   perform Write-Log-Record
               end-if
           end-if.

       Check-Driver-On-Library-Path section.
           perform Get-Section-Details
           if Driver-Library = spaces
               move "Cannot determine location of driver" to Log-Record
               perform Write-Log-Record
               move 1 to Error-Flag
           else
               call "CBL_SPLIT_FILENAME" using Split-Join-Param
                                               Driver-Library
                                         returning Status-Code
               if Status-Code not = 0
                   move 1 to Error-Flag
               else
                   if Path-Len not = 0
      *                The filename does include a path
                       move Driver-Library(Path-Strt:Path-Len)
                         to Environment-String
      *                Remove any trailing "/"
                       if Environment-String(Path-Len:1) = "/"
                           move space to Environment-String(Path-Len:1)
                           subtract 1 from Path-Len
                       end-if
                       move Environment-String to Odbc-Library-Path
      *                Look for the string on the library path
                       move 1 to Char-Ptr
                       inspect Unix-Library-Path tallying Char-Ptr
                           for characters before
                           initial Environment-String(1:Path-Len)
                       if Unix-Env = Aix-Env
                            move "LIBPATH" to Work-String
                       else
                            move "LD_LIBRARY_PATH" to Work-String
                       end-if
                       if Char-Ptr > 256
                           display ODBC-Library-Message
                           move spaces to Log-Record
                           string Environment-String(1:Path-Len)
                                  delimited by size
                                  " not on " delimited by size
                                  Work-String delimited by space
                             into Log-Record
                           perform Write-Log-Record
                           move 1 to Error-Flag
                       else
                           move spaces to Log-Record
                           string Environment-String(1:Path-Len)
                                  delimited by size
                                  " on " delimited by size
                                  Work-String delimited by space
                             into Log-Record
                           perform Write-Log-Record
                       end-if
                   end-if
               end-if
           end-if.

       Find-Driver-Section section.
           move 0 to Error-Flag
      *    Look through the file looking for the section
      *    Corresponding to the selected driver name
           move function upper-case(Data-Source-Name(Highlit-Line))
             to Work-Name
           move 30 to String-Len
           perform until Work-Name(String-Len:1) not = space
               subtract 1 from String-Len
           end-perform
           move 1 to Current-Rec-Ptr
           move 0 to Text-Found-Flag
           perform until Text-Found-Flag = 1 or
                         Error-Flag = 1
               perform Look-For-New-Odbcini-Section
               if Work-Record(1:5) = "[END]"
      *            We've hit the end of the file without
      *            finding the section we are looking for -
      *            this is an error
                   move 1 to Error-Flag
               else
      *            Look to see if this is the section
      *            corresponding to the driver that is selected
                   move 1 to Char-Ptr
                   inspect Work-Record tallying Char-Ptr
                       for characters
                       before initial Work-Name(1:String-Len)
                   if Char-Ptr < 256
                       move 1 to Text-Found-Flag
                   end-if
                   move Current-Rec-Ptr to Section-Location
                   add 1 to Current-Rec-Ptr
               end-if
           end-perform.

       Report-Connect-Error section.
      *    If the ODBC driver manager cannot load the driver then
      *    a generic error is put out. Display a database specific
      *    error if possible
           move spaces to Log-Record
           string "Connect error : " delimited by size
                  MfSQLMessageText(1:140) delimited by size
             into Log-Record
           perform Write-Log-Record
           if MfSQLMessageText(1:36) = Cannot-Load-Driver
               evaluate Driver-Env
                   when Unknown-Driver-Env
                       display Unable-To-Load-Driver-Generic

                   when Oracle-Env
                       display Unable-To-Load-Driver-Oracle

                   when Sybase-Env
                       display Unable-To-Load-Driver-Oracle

                   when Informix-Env
                       display Unable-To-Load-Driver-Informix

               end-evaluate
           else
      *        The driver could not connect. Display the complete
      *        error message which will have been placed in
      *        MfSQLMessageText by OpenESQL
               display Error-On-Connect
           end-if.

       Get-Section-Details section.
      *    Retrieve the information about the driver
      *    the user has selected.
           perform Find-Driver-Section
           move spaces to Driver-Section-Information
           move 0 to Driver-Option-Count
           perform until Odbcini-Record(Current-Rec-Ptr)(1:1) = "["
               move Odbcini-Record(Current-Rec-Ptr)
                 to Work-Record
               if Work-Record not = spaces
                   move 1 to Char-Ptr
                   inspect Work-Record tallying Char-Ptr
                       for characters before initial "="
                   move Work-Record(1:Char-Ptr + -1) to Option-Name
                   move 256 to String-Len
                   perform until Work-Record(String-Len:1) not = space
                       subtract 1 from String-Len
                   end-perform
                   if String-Len = Char-Ptr
      *                The option value is blank
                       move 1 to String-Len
                       add 1 to Char-Ptr
                   else
                       add 1 to Char-Ptr
                       perform until Work-Record(Char-Ptr:1) not = space
                           add 1 to Char-Ptr
                       end-perform
                       subtract Char-Ptr from String-Len
                       add 1 to String-Len
                   end-if
                   move function upper-case(Option-Name)
                     to Option-Name-Upper
                   evaluate Option-Name-Upper
                       when "DRIVER"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Library

                       when "DESCRIPTION"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Description

                       when "SERVERNAME"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Server-Name

                       when "DATABASE"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Database

                       when "LOGONID"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-LogonID

                       when "PASSWORD"
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Password

                       when other
                           add 1 to Driver-Option-Count
                           move Option-Name
                             to Driver-Option-Name(Driver-Option-Count)
                           move Work-Record(Char-Ptr:String-Len)
                             to Driver-Option-Value(Driver-Option-Count)

                   end-evaluate
               end-if
               add 1 to Current-Rec-Ptr
            end-perform.

       Write-Section-Details section.
           if Section-Location not = 0
               perform Delete-Section
           end-if
      *    Insert the new section after the Data Sources section
           move 1 to Current-Rec-Ptr
           perform Look-For-New-Odbcini-Section
           move Current-Rec-Ptr to Section-Location
      *    Determine how many lines we need to insert
           move 8 to Insert-Count
           add Driver-Option-Count to Insert-Count
           move Odbcini-Record-Count to Current-Rec-Ptr
           move Odbcini-Record-Count to Save-Rec-Ptr
           add Insert-Count to Save-Rec-Ptr
           perform with test after
                   until Current-Rec-Ptr < Section-Location
               move Odbcini-Record(Current-Rec-Ptr)
                 to Odbcini-Record(Save-Rec-Ptr)
               subtract 1 from Current-Rec-Ptr
               subtract 1 from Save-Rec-Ptr
           end-perform
           add Insert-Count to Odbcini-Record-Count
      *    Now insert the new section
           move spaces to Work-Record
           string "[" delimited by size
                  Work-Name delimited by space
                  "]" delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "Driver=" delimited by size
                  Driver-Library delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "Description=" delimited by size
                  Driver-Description delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "ServerName=" delimited by size
                  Driver-Server-Name delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "Database=" delimited by size
                  Driver-Database delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "LogonID=" delimited by size
                  Driver-LogonID delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move spaces to Work-Record
           string "Password=" delimited by size
                  Driver-Password delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move 1 to Insert-Count
           perform until Insert-Count > Driver-Option-Count
               move spaces to Work-Record
               string Driver-Option-Name(Insert-Count)
                      delimited by space
                      "=" delimited by size
                      Driver-Option-Value(Insert-Count)
                      delimited by size
                 into Work-Record
               move Work-Record to Odbcini-Record(Section-Location)
               add 1 to Section-Location
               add 1 to Insert-Count
           end-perform
           move spaces to Work-Record
           move Work-Record to Odbcini-Record(Section-Location)
           add 1 to Section-Location
           move 1 to Odbcini-Changed.

       Delete-Section section.
           move 1 to Odbcini-Changed
           move Section-Location to Current-Rec-Ptr
           perform Look-For-New-Odbcini-Section
           move 0 to Text-Found-Flag
           perform with test after until Text-Found-Flag = 1
               move Odbcini-Record(Current-Rec-Ptr)
                 to Odbcini-Record(Section-Location)
               if Odbcini-Record(Current-Rec-Ptr)(1:5) = "[END]"
                   move 1 to Text-Found-Flag
               else
                   add 1 to Current-Rec-Ptr
                   add 1 to Section-Location
               end-if
           end-perform
           move Current-Rec-Ptr to Odbcini-Record-Count.

       Edit-Data-Source section.
      *    Edit a data source entry
           perform Get-Section-Details
           move Data-Source-Name(Highlit-Line) to Work-Name
           perform Edit-Data-Source-Information.

       Edit-Data-Source-Information section.
           display Edit-Data-Source-Screen
           accept Edit-Data-Source-Screen
           if (Key-Type = "1" and Key-Code-1 = F2-Key) or
              (Key-Type = "3" and Key-Code-1x = "A") or
              (Key-Type = "3" and Key-Code-1x = "a")
               display Additional-Options-Screen
               accept Additional-Options-Screen
               move 16 to Driver-Option-Count
               perform until Driver-Option-Count = 0 or
                             Driver-Option-Name(Driver-Option-Count)
                                   not = spaces
                   subtract 1 from Driver-Option-Count
               end-perform
               go to Edit-Data-Source-Information
           end-if
           if Key-Type not = "1" or Key-Code-1 not = Escape-Key
               perform Write-Section-Details
           end-if.

       Add-Data-Source section.
           move spaces to Driver-Section-Information
           move 0 to Driver-Option-Count
           move 0 to Section-Location
           display Driver-List-Screen
           accept Driver-List-Screen
           if Driver-Number > Driver-Count or
              Driver-Number < 1
               go to Add-Data-Source
           end-if
           display Get-Data-Source-Name
           accept Get-Data-Source-Name
      *    Find out where the driver is to be installed by
      *    looking for the InstallDir entry. Start at the end
      *    of the file as it is more likely to be at the end
           move Odbcini-Record-Count to Current-Rec-Ptr
           move 0 to Text-Found-Flag
           perform until Text-Found-Flag = 1 or
                         Current-Rec-Ptr = 1
               move function upper-case(Odbcini-Record(Current-Rec-Ptr))
                 to Work-Record
               move 1 to Char-Ptr
               inspect Work-Record tallying Char-Ptr
                   for characters before initial "INSTALLDIR"
               if Char-Ptr < 256
                   move 1 to Text-Found-Flag
               else
                   subtract 1 from Current-Rec-Ptr
               end-if
           end-perform
           if Text-Found-Flag not = 0
               add 10 to Char-Ptr
               perform until Work-Record(Char-Ptr:1) not = space and
                             Work-Record(Char-Ptr:1) not = "="
                   add 1 to Char-Ptr
               end-perform
               string Odbcini-Record(Current-Rec-Ptr)(Char-Ptr:)
                      delimited by space
                      "/lib/" delimited by size
                      Driver-Object(Driver-Number) delimited by space
                      ".so" delimited by size
                   into Driver-Library
           else
               String Driver-Object(Driver-Number) delimited by space
                      ".so" delimited by size
                   into Driver-Library
           end-if
           perform Edit-Data-Source-Information
           perform Add-Data-Source-To-List.

       Add-Data-Source-To-List section.
           add 1 to Data-Source-Count
           move Work-Name to Data-Source-Name(Data-Source-Count)
           move Driver-Name(Driver-Number)
             to Data-Source-Driver(Data-Source-Count)
      *    Now, insert the new record into the file at
      *    the start of the Data Sources section
           move 0 to Current-Rec-Ptr
           perform with test after
                   until Work-Record(2:17) = "ODBC DATA SOURCES"
               perform Look-For-New-Odbcini-Section
           end-perform
           add 1 to Current-Rec-Ptr
           move Current-Rec-Ptr to Save-Rec-Ptr
           move Odbcini-Record-Count to Current-Rec-Ptr
           move Odbcini-Record-Count to Section-Location
           add 1 to Section-Location
           perform until Current-Rec-Ptr < Save-Rec-Ptr
               move Odbcini-Record(Current-Rec-Ptr)
                 to Odbcini-Record(Section-Location)
               subtract 1 from Current-Rec-Ptr
               subtract 1 from Section-Location
           end-perform
           add 1 to Odbcini-Record-Count
           move spaces to Work-Record
           string Work-Name delimited by spaces
                  "=" delimited by size
                  Driver-Name(Driver-Number) delimited by size
             into Work-Record
           move Work-Record to Odbcini-Record(Save-Rec-Ptr)
           move Data-Source-Count to Highlit-Line
           move Data-Source-Count to Data-Source-Ptr
           divide 16 into Data-Source-Ptr
           multiply 16 by Data-Source-Ptr
           add 1 to Data-Source-Ptr.

       Delete-Data-Source section.
           perform Find-Driver-Section
           move Data-Source-Name(Highlit-Line) to Work-Name
           display Delete-Data-Source-Screen
           accept Delete-Data-Source-Screen
           if Char-Response = "Y" or Char-Response = "y"
      *        Remove it from the list of data sources
               If Highlit-Line not = Data-Source-Count
                   move Highlit-Line to Data-Source-Ptr
                   move Highlit-Line to Data-Source-Ptr2
                   add 1 to Data-Source-Ptr2
                   perform until Data-Source-Ptr = Data-Source-Count
                       move Data-Source-Record(Data-Source-Ptr2)
                         to Data-Source-Record(Data-Source-Ptr)
                       add 1 to Data-Source-Ptr
                       add 1 to Data-Source-Ptr2
                   end-perform
               end-if
               move spaces to Data-Source-Record(Data-Source-Count)
               subtract 1 from Data-Source-Count
      *        Now remove the entry from the Data Sources section in
      *        odbc.ini
               move 0 to Current-Rec-Ptr
               perform with test after
                       until Work-Record(2:17) = "ODBC DATA SOURCES"
                   perform Look-For-New-Odbcini-Section
               end-perform
               add 1 to Current-Rec-Ptr
               move 30 to String-Len
               perform until Work-Name(String-Len:1) not = space
                   subtract 1 from String-Len
               end-perform
               perform until
                       Odbcini-Record(Current-Rec-Ptr)(1:String-Len)
                               = Work-Name(1:String-Len)
                   add 1 to Current-Rec-Ptr
               end-perform
               move Current-Rec-Ptr to Save-Rec-Ptr
               add 1 to Save-Rec-Ptr
               perform until Current-Rec-Ptr = Odbcini-Record-Count
                   move Odbcini-Record(Save-Rec-Ptr)
                     to Odbcini-Record(Current-Rec-Ptr)
                   add 1 to Current-Rec-Ptr
                   add 1 to Save-Rec-Ptr
               end-perform
               subtract 1 from Odbcini-Record-Count
      *        Adjust Section-Location to accomodate the
      *        line deleted above
               subtract 1 from Section-Location
               perform Delete-Section
               if Highlit-Line > Data-Source-Count
                   move Data-Source-Count to Highlit-Line
               end-if
               move Highlit-Line to Data-Source-Ptr
               divide 16 into Data-Source-Ptr
               multiply 16 by Data-Source-Ptr
               add 1 to Data-Source-Ptr
           end-if.

       Write-Log-Record section.
           if Log-File-Open-Flag not = 0
               write Log-Record
           end-if.

       Initialization section.
           display Startup-Screen
           open output Log-File
           if Log-File-Status-1 = "0"
               move 1 to Log-File-Open-Flag
           else
               move 0 to Log-File-Open-Flag
           end-if
      *    Enable detection of Escape and Function keys F1 - F5
           call x"AF" using Set-Bit-Pairs Enable-Function-Keys
      *    Enable detection of PgUp and PgDn
           call x"AF" using Set-Bit-Pairs Enable-Pgup-PgDn
      *    Determine which UNIX we are running on
           move Unknown-Unix-Env to Unix-Env
           move "Unknown UNIX version" to Log-Record
           open input Unix-Version
           if Unix-Version-Status-1 = "0"
               read Unix-Version
               if Unix-Version-Status-1 = "0" or
                  Unix-Version-Status-1 = "1"
                   evaluate true
                   when Unix-Details(1:5) = "SunOS"
                       move Solaris-Env to Unix-Env
                       move "Solaris Detected" to Log-Record
                       display "LD_LIBRARY_PATH" upon environment-name
                       accept Unix-Library-Path from environment-value

                   when Unix-Details(1:3) = "AIX"
                       move Aix-Env to Unix-Env
                       move "AIX Detected" to Log-Record
                       display "LIBPATH" upon environment-name
                       accept Unix-Library-Path from environment-value

                   end-evaluate
               end-if
               close Unix-Version
           end-if
           perform Write-Log-Record.

       Termination section.
      *    Ensure that any changes are written out
           display spaces upon crt
           if Odbcini-Changed = 1
               move 0 to Error-Flag
               perform Flush-Odbcini
               if Error-Flag = 0 and Odbcini-Location = 1
                   move spaces to Environment-String
                   call "CBL_GET_CURRENT_DIR"
                       using by value Dir-Flags
                             by value Dir-Length
                             by reference Environment-String
                       returning Status-Code
                   string Environment-String delimited by space
                          "/odbc.ini" delimited by size
                     into Work-String
                   display Set-Odbcini
               end-if
           end-if
           if Log-File-Open-Flag not = 0
               close Log-File
           end-if.

