/****************************************************************************
 *
 *	Copyright (C) 1984-1998 Micro Focus Ltd.
 *
 *	All rights reserved.  Unpublished, all rights reserved under
 *	copyright law and international treaty.  Use of a copyright notice
 *	is precautionary only and does not imply publication or disclosure.
 *	This software contains confidential information and trade secrets of
 *	Micro Focus Ltd. and no part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form
 *	or by any means, electronic, mechanical, magnetic, optical, chemical,
 *	manual or otherwise, without the prior written permission of:
 *
 *	Micro Focus Ltd,
 *	The Lawn, Old Bath Road, Newbury, Berkshire, RG14 1QN, UK.
 *	(01635) 32646
 *
 *	RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions as set forth in subparagraph (c)(1)(ii) of the Rights
 *	in Technical Data and Computer Software clause at DFARS 52.227-7013
 *	or subparagraphs (c)(1) and (2) of Commercial Computer Software -
 *	Restricted Rights at 48 CFR 52.227-19, as applicable.  Contact
 *	Micro Focus Incorporated, 701 East Middlefield Road, Mountain View,
 *	California 94043, USA.
 *
 *	Genesis Run Time System (M3/Hawaii Freeze)
 *
 *	@(#)cobscreen.h	3.3
 *
 *	Last Modified on 98/10/21 at 10:05:21
 *
 ****************************************************************************/

/** Start of source module cobscreen.h **/

#ifndef _COBSCREEN_H
#define _COBSCREEN_H

/* This file, which is supplied in $COBDIR/include, prototypes the documented
 * cob prefix screen handling routines.
 */

#ifdef	__cplusplus
extern "C" {
#endif

#include "mf_types.h"

/* These attributes are based upon the default attribute byte value (see
 * your documentation for details) but have been shifted left.
 */
#define	A_NORMAL	0x00 << 8	/* normal, no attributes */
#define	A_BOLD		0x01 << 8	/* bold */
#define	A_UNDER		0x02 << 8	/* underline */
#define	A_REVERSE	0x04 << 8	/* reverse video */
#define	A_BLINK		0x08 << 8	/* blinking */
#define	A_DIM		0x40 << 8	/* dim */

/* combined characters and attributes should be of type 'cobchtype' */
typedef	unsigned short cobchtype;

/* external definitions */
void cobmove(int y, int x);
void cobaddch(cobchtype ch);
int  cobaddstr(const cobchtype *s);
int  cobaddstrc(const mf_uns8 *s);
int  cobprintf(const mf_uns8 *fmt, ...);
void cobscroll(int top, int bot);
void cobclear(void);
int  cobgetch(void);
int  cobkeypad(int mode);
int  cobtermmode(const mf_uns8 *mode);
int  coblines(void);
int  cobcols(void);

#ifdef	__cplusplus
}
#endif

#endif /* _COBSCREEN_H */

/** End of source module cobscreen.h **/
