      *>----------------------------------------------------------------
      *> The PicXToObject class is the Association class initialized
      *> as a template for storing 32 character strings as keys, and
      *> object references as data. It is equivalent to the class
      *> returned if you send the "newClass" message to Association, and
      *> specify CobolPicX32 as key and a null object reference as data.
      *>
      *>#See class "associtn".
      *>#See class "picx32".
      *>
      *> Copyright (C) 1991,1997 Micro Focus Ltd.
      *>
      *>----------------------------------------------------------------
      $set mfoo

       Class-id. PicXToObject
              data is protected
              inherits from Association
              with data.

       Object section.

       Class-control.
           Association  is class "associtn"
           PicXToObject is class "picxtoob"
           CobolPicX32  is class "picx32"
           .

       procedure division.
           invoke self "initializeclass".
           exit program.

       class-object.

       object-storage section.

      *>----------------------------------------------------------------
      *> PRIVATE. initialize class data
      *>----------------------------------------------------------------
       method-id. "initializeclass".
       procedure division.
           invoke super "initializeclass"
           set keytemplate to CobolPicX32
           set datatemplate to null
           move 32 to keysize
           move objectReferenceSize to datasize
                                       storagerequirements
           add 32 to storagerequirements
           exit method.
       end method "initializeclass".

       end class-object.

       object.
      *------------------------------------------------------------
      * Insert your object instance data declarations here
      *------------------------------------------------------------
       object-storage section.
       end object.
       end class PicXToObject.
